input-method-cache revision 5887
#!/bin/ksh -p
#
# Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, and/or sell copies of the Software, and to permit persons
# to whom the Software is furnished to do so, provided that the above
# copyright notice(s) and this permission notice appear in all copies of
# the Software and that both the above copyright notice(s) and this
# permission notice appear in supporting documentation.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
# OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
# INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# Except as contained in this notice, the name of a copyright holder
# shall not be used in advertising or otherwise to promote the sale, use
# or other dealings in this Software without prior written authorization
# of the copyright holder.
#
###########################################################################
#
PATH=/usr/bin:/usr/sbin
. /lib/svc/share/smf_include.sh
USAGE="Usage: $0 { start | refresh }"
FIND_NEWER=/usr/share/desktop-cache/find_newer
if [ $# -ne 1 ] ; then
echo $USAGE
exit 2
fi
#
# for each architecture
# if cache file exist
# get the list of modules newer than the cache file
# else
# make list greater than zero
#
# if list generate cache
#
ARCH64=`/bin/isainfo -k`
if [[ $ARCH64 != "amd64" ]] && [[ "$ARCH64" != "sparcv9" ]]; then
ARCH64=""
fi
start_input_method_cache ()
{
for DIR in "" $ARCH64; do
test -x /usr/bin/$DIR/gtk-query-immodules-2.0 || {
echo "gtk-query-immodules-2.0 not installed"
continue
}
test -w /etc/$DIR/gtk-2.0 || {
echo "/etc/$DIR/gtk-2.0 is not writable, skipping."
return
}
if [ -a "/etc/$DIR/gtk-2.0/gtk.immodules" ]; then
RESULT=`${FIND_NEWER} -c -f -m --name '*.so' \
--newer /etc/$DIR/gtk-2.0/gtk.immodules \
/usr/lib/$DIR/gtk-2.0/*/immodules 2>/dev/null`
else
RESULT="no cache file"
fi
if [ -n "$RESULT" ]; then
echo "updating/creating im modules cache file"
/usr/bin/$DIR/gtk-query-immodules-2.0 /usr/lib/$DIR/gtk-2.0/*/immodules/*.so \
> /etc/$DIR/gtk-2.0/gtk.immodules
if [ $? -ne 0 ]; then
echo "gtk-query-immodules-2.0 exited with an error while generating the cache file /etc/$DIR/gtk-2.0/gtk.immodules"
exit $SMF_EXIT_ERR_FATAL
else
echo "input method cache installed in /etc/$DIR/gtk-2.0/gtk.immodules"
fi
fi
done
}
refresh_input_method_cache ()
{
for DIR in "" $ARCH64; do
test -x /usr/bin/$DIR/gtk-query-immodules-2.0 || {
echo "gtk-query-immodules-2.0 not installed"
continue
}
test -w /etc/$DIR/gtk-2.0 || {
echo "/etc/$DIR/gtk-2.0 is not writable, skipping."
return
}
if [ -a "/etc/$DIR/gtk-2.0/gtk.immodules" ]; then
RESULT=`/usr/bin/find /usr/lib/$DIR/gtk-2.0/*/immodules/*.so ! -type d \
-follow 2>/dev/null`
else
RESULT="no cache file"
fi
if [ -n "$RESULT" ]; then
echo "updating/creating im modules cache file"
/usr/bin/$DIR/gtk-query-immodules-2.0 /usr/lib/$DIR/gtk-2.0/*/immodules/*.so \
> /etc/$DIR/gtk-2.0/gtk.immodules
if [ $? -ne 0 ]; then
echo "gtk-query-immodules-2.0 exited with an error while generating the cache file /etc/$DIR/gtk-2.0/gtk.immodules"
exit $SMF_EXIT_ERR_FATAL
else
echo "input method cache installed in /etc/$DIR/gtk-2.0/gtk.immodules"
fi
fi
done
}
METHOD=$1
case "$METHOD" in
'start')
# Continue with rest of script
;;
'refresh')
# Continue with rest of script
;;
-*)
echo $USAGE
exit 2
;;
*)
echo "Invalid method $METHOD"
exit 2
;;
esac
${METHOD}_input_method_cache
exit $SMF_EXIT_OK